/// <reference types="jquery/misc" />
/// <reference types="jquery/jquerystatic" />
import { HttpResponseModel, ODataHttpClient } from "@odata2ts/http-client-api";
import { AjaxRequestConfig } from "./AjaxRequestConfig";
export type ErrorMessageRetriever = (errorResponse: any) => string | undefined;
export interface ClientOptions {
    useCsrfProtection?: boolean;
    csrfTokenFetchUrl?: string;
}
export declare const getV2OrV4ErrorMessage: ErrorMessageRetriever;
export declare class JQueryClient implements ODataHttpClient<AjaxRequestConfig> {
    private clientOptions?;
    private readonly client;
    private readonly config;
    private csrfToken;
    private getErrorMessage;
    constructor(jquery: JQueryStatic, config?: AjaxRequestConfig, clientOptions?: ClientOptions | undefined);
    setErrorMessageRetriever(getErrorMsg: ErrorMessageRetriever): void;
    private setupSecurityToken;
    private fetchSecurityToken;
    private sendRequest;
    private prepareData;
    post<ResponseModel>(url: string, data: any, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseModel>>;
    get<ResponseModel>(url: string, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseModel>>;
    put<ResponseModel>(url: string, data: any, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseModel>>;
    patch<ResponseModel>(url: string, data: any, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseModel>>;
    merge<ResponseModel>(url: string, data: any, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseModel>>;
    delete(url: string, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<void>>;
}
